#!/usr/bin/perl -w
#
# Copyright (C) 2001,2002 asdfGroup.com Inc. All rights reserved.
#
# This library is a commercial product and it is subject to the license
# agreement that can be found at the following URL:
#   http://www.asdfGroup.com/license.html
# Please contact our staff if you will have any questions:
#   mailto:staff@asdfGroup.com
#

use strict;

sub MD5 {
    use integer;
    my $msg = join '', @_;
    my $b = length($msg) * 8;
    my $pad = (((448+512) - ($b % 512)) % 512) || 512;
    $msg .= chr(0x80) . (chr(0) x ($pad/8-1)) . pack("VV",$b,0);
    my $A = 0x67452301;
    my $B = 0xefcdab89;
    my $C = 0x98badcfe;
    my $D = 0x10325476;
    for my $i (0 .. length($msg)/64-1) {
        my @X = unpack "V16", substr($msg, $i*64, 64);
        my $AA = $A;
        my $BB = $B;
        my $CC = $C;
        my $DD = $D;
        $A = $A+($D^($B&($C^$D)))+$X[0]+0xd76aa478;
        $A = $B + (($A << 7) | (($A >> (32-7)) & ((1 << 7) - 1)) );
        $D = $D+($C^($A&($B^$C)))+$X[1]+0xe8c7b756;
        $D = $A + (($D << 12) | (($D >> (32-12)) & ((1 << 12) - 1)) );
        $C = $C+($B^($D&($A^$B)))+$X[2]+0x242070db;
        $C = $D + (($C << 17) | (($C >> (32-17)) & ((1 << 17) - 1)) );
        $B = $B+($A^($C&($D^$A)))+$X[3]+0xc1bdceee;
        $B = $C + (($B << 22) | (($B >> (32-22)) & ((1 << 22) - 1)) );
        $A = $A+($D^($B&($C^$D)))+$X[4]+0xf57c0faf;
        $A = $B + (($A << 7) | (($A >> (32-7)) & ((1 << 7) - 1)) );
        $D = $D+($C^($A&($B^$C)))+$X[5]+0x4787c62a;
        $D = $A + (($D << 12) | (($D >> (32-12)) & ((1 << 12) - 1)) );
        $C = $C+($B^($D&($A^$B)))+$X[6]+0xa8304613;
        $C = $D + (($C << 17) | (($C >> (32-17)) & ((1 << 17) - 1)) );
        $B = $B+($A^($C&($D^$A)))+$X[7]+0xfd469501;
        $B = $C + (($B << 22) | (($B >> (32-22)) & ((1 << 22) - 1)) );
        $A = $A+($D^($B&($C^$D)))+$X[8]+0x698098d8;
        $A = $B + (($A << 7) | (($A >> (32-7)) & ((1 << 7) - 1)) );
        $D = $D+($C^($A&($B^$C)))+$X[9]+0x8b44f7af;
        $D = $A + (($D << 12) | (($D >> (32-12)) & ((1 << 12) - 1)) );
        $C = $C+($B^($D&($A^$B)))+$X[10]+0xffff5bb1;
        $C = $D + (($C << 17) | (($C >> (32-17)) & ((1 << 17) - 1)) );
        $B = $B+($A^($C&($D^$A)))+$X[11]+0x895cd7be;
        $B = $C + (($B << 22) | (($B >> (32-22)) & ((1 << 22) - 1)) );
        $A = $A+($D^($B&($C^$D)))+$X[12]+0x6b901122;
        $A = $B + (($A << 7) | (($A >> (32-7)) & ((1 << 7) - 1)) );
        $D = $D+($C^($A&($B^$C)))+$X[13]+0xfd987193;
        $D = $A + (($D << 12) | (($D >> (32-12)) & ((1 << 12) - 1)) );
        $C = $C+($B^($D&($A^$B)))+$X[14]+0xa679438e;
        $C = $D + (($C << 17) | (($C >> (32-17)) & ((1 << 17) - 1)) );
        $B = $B+($A^($C&($D^$A)))+$X[15]+0x49b40821;
        $B = $C + (($B << 22) | (($B >> (32-22)) & ((1 << 22) - 1)) );
        $A = $A+($C^($D&($B^$C)))+$X[1]+0xf61e2562;
        $A = $B + (($A << 5) | (($A >> (32-5)) & ((1 << 5) - 1)) );
        $D = $D+($B^($C&($A^$B)))+$X[6]+0xc040b340;
        $D = $A + (($D << 9) | (($D >> (32-9)) & ((1 << 9) - 1)) );
        $C = $C+($A^($B&($D^$A)))+$X[11]+0x265e5a51;
        $C = $D + (($C << 14) | (($C >> (32-14)) & ((1 << 14) - 1)) );
        $B = $B+($D^($A&($C^$D)))+$X[0]+0xe9b6c7aa;
        $B = $C + (($B << 20) | (($B >> (32-20)) & ((1 << 20) - 1)) );
        $A = $A+($C^($D&($B^$C)))+$X[5]+0xd62f105d;
        $A = $B + (($A << 5) | (($A >> (32-5)) & ((1 << 5) - 1)) );
        $D = $D+($B^($C&($A^$B)))+$X[10]+0x02441453;
        $D = $A + (($D << 9) | (($D >> (32-9)) & ((1 << 9) - 1)) );
        $C = $C+($A^($B&($D^$A)))+$X[15]+0xd8a1e681;
        $C = $D + (($C << 14) | (($C >> (32-14)) & ((1 << 14) - 1)) );
        $B = $B+($D^($A&($C^$D)))+$X[4]+0xe7d3fbc8;
        $B = $C + (($B << 20) | (($B >> (32-20)) & ((1 << 20) - 1)) );
        $A = $A+($C^($D&($B^$C)))+$X[9]+0x21e1cde6;
        $A = $B + (($A << 5) | (($A >> (32-5)) & ((1 << 5) - 1)) );
        $D = $D+($B^($C&($A^$B)))+$X[14]+0xc33707d6;
        $D = $A + (($D << 9) | (($D >> (32-9)) & ((1 << 9) - 1)) );
        $C = $C+($A^($B&($D^$A)))+$X[3]+0xf4d50d87;
        $C = $D + (($C << 14) | (($C >> (32-14)) & ((1 << 14) - 1)) );
        $B = $B+($D^($A&($C^$D)))+$X[8]+0x455a14ed;
        $B = $C + (($B << 20) | (($B >> (32-20)) & ((1 << 20) - 1)) );
        $A = $A+($C^($D&($B^$C)))+$X[13]+0xa9e3e905;
        $A = $B + (($A << 5) | (($A >> (32-5)) & ((1 << 5) - 1)) );
        $D = $D+($B^($C&($A^$B)))+$X[2]+0xfcefa3f8;
        $D = $A + (($D << 9) | (($D >> (32-9)) & ((1 << 9) - 1)) );
        $C = $C+($A^($B&($D^$A)))+$X[7]+0x676f02d9;
        $C = $D + (($C << 14) | (($C >> (32-14)) & ((1 << 14) - 1)) );
        $B = $B+($D^($A&($C^$D)))+$X[12]+0x8d2a4c8a;
        $B = $C + (($B << 20) | (($B >> (32-20)) & ((1 << 20) - 1)) );
        $A = $A+($B ^ $C ^ $D)+$X[5]+0xfffa3942;
        $A = $B + (($A << 4) | (($A >> (32-4)) & ((1 << 4) - 1)) );
        $D = $D+($A ^ $B ^ $C)+$X[8]+0x8771f681;
        $D = $A + (($D << 11) | (($D >> (32-11)) & ((1 << 11) - 1)) );
        $C = $C+($D ^ $A ^ $B)+$X[11]+0x6d9d6122;
        $C = $D + (($C << 16) | (($C >> (32-16)) & ((1 << 16) - 1)) );
        $B = $B+($C ^ $D ^ $A)+$X[14]+0xfde5380c;
        $B = $C + (($B << 23) | (($B >> (32-23)) & ((1 << 23) - 1)) );
        $A = $A+($B ^ $C ^ $D)+$X[1]+0xa4beea44;
        $A = $B + (($A << 4) | (($A >> (32-4)) & ((1 << 4) - 1)) );
        $D = $D+($A ^ $B ^ $C)+$X[4]+0x4bdecfa9;
        $D = $A + (($D << 11) | (($D >> (32-11)) & ((1 << 11) - 1)) );
        $C = $C+($D ^ $A ^ $B)+$X[7]+0xf6bb4b60;
        $C = $D + (($C << 16) | (($C >> (32-16)) & ((1 << 16) - 1)) );
        $B = $B+($C ^ $D ^ $A)+$X[10]+0xbebfbc70;
        $B = $C + (($B << 23) | (($B >> (32-23)) & ((1 << 23) - 1)) );
        $A = $A+($B ^ $C ^ $D)+$X[13]+0x289b7ec6;
        $A = $B + (($A << 4) | (($A >> (32-4)) & ((1 << 4) - 1)) );
        $D = $D+($A ^ $B ^ $C)+$X[0]+0xeaa127fa;
        $D = $A + (($D << 11) | (($D >> (32-11)) & ((1 << 11) - 1)) );
        $C = $C+($D ^ $A ^ $B)+$X[3]+0xd4ef3085;
        $C = $D + (($C << 16) | (($C >> (32-16)) & ((1 << 16) - 1)) );
        $B = $B+($C ^ $D ^ $A)+$X[6]+0x04881d05;
        $B = $C + (($B << 23) | (($B >> (32-23)) & ((1 << 23) - 1)) );
        $A = $A+($B ^ $C ^ $D)+$X[9]+0xd9d4d039;
        $A = $B + (($A << 4) | (($A >> (32-4)) & ((1 << 4) - 1)) );
        $D = $D+($A ^ $B ^ $C)+$X[12]+0xe6db99e5;
        $D = $A + (($D << 11) | (($D >> (32-11)) & ((1 << 11) - 1)) );
        $C = $C+($D ^ $A ^ $B)+$X[15]+0x1fa27cf8;
        $C = $D + (($C << 16) | (($C >> (32-16)) & ((1 << 16) - 1)) );
        $B = $B+($C ^ $D ^ $A)+$X[2]+0xc4ac5665;
        $B = $C + (($B << 23) | (($B >> (32-23)) & ((1 << 23) - 1)) );
        $A = $A+($C ^ ($B | (~$D)))+$X[0]+0xf4292244;
        $A = $B + (($A << 6) | (($A >> (32-6)) & ((1 << 6) - 1)) );
        $D = $D+($B ^ ($A | (~$C)))+$X[7]+0x432aff97;
        $D = $A + (($D << 10) | (($D >> (32-10)) & ((1 << 10) - 1)) );
        $C = $C+($A ^ ($D | (~$B)))+$X[14]+0xab9423a7;
        $C = $D + (($C << 15) | (($C >> (32-15)) & ((1 << 15) - 1)) );
        $B = $B+($D ^ ($C | (~$A)))+$X[5]+0xfc93a039;
        $B = $C + (($B << 21) | (($B >> (32-21)) & ((1 << 21) - 1)) );
        $A = $A+($C ^ ($B | (~$D)))+$X[12]+0x655b59c3;
        $A = $B + (($A << 6) | (($A >> (32-6)) & ((1 << 6) - 1)) );
        $D = $D+($B ^ ($A | (~$C)))+$X[3]+0x8f0ccc92;
        $D = $A + (($D << 10) | (($D >> (32-10)) & ((1 << 10) - 1)) );
        $C = $C+($A ^ ($D | (~$B)))+$X[10]+0xffeff47d;
        $C = $D + (($C << 15) | (($C >> (32-15)) & ((1 << 15) - 1)) );
        $B = $B+($D ^ ($C | (~$A)))+$X[1]+0x85845dd1;
        $B = $C + (($B << 21) | (($B >> (32-21)) & ((1 << 21) - 1)) );
        $A = $A+($C ^ ($B | (~$D)))+$X[8]+0x6fa87e4f;
        $A = $B + (($A << 6) | (($A >> (32-6)) & ((1 << 6) - 1)) );
        $D = $D+($B ^ ($A | (~$C)))+$X[15]+0xfe2ce6e0;
        $D = $A + (($D << 10) | (($D >> (32-10)) & ((1 << 10) - 1)) );
        $C = $C+($A ^ ($D | (~$B)))+$X[6]+0xa3014314;
        $C = $D + (($C << 15) | (($C >> (32-15)) & ((1 << 15) - 1)) );
        $B = $B+($D ^ ($C | (~$A)))+$X[13]+0x4e0811a1;
        $B = $C + (($B << 21) | (($B >> (32-21)) & ((1 << 21) - 1)) );
        $A = $A+($C ^ ($B | (~$D)))+$X[4]+0xf7537e82;
        $A = $B + (($A << 6) | (($A >> (32-6)) & ((1 << 6) - 1)) );
        $D = $D+($B ^ ($A | (~$C)))+$X[11]+0xbd3af235;
        $D = $A + (($D << 10) | (($D >> (32-10)) & ((1 << 10) - 1)) );
        $C = $C+($A ^ ($D | (~$B)))+$X[2]+0x2ad7d2bb;
        $C = $D + (($C << 15) | (($C >> (32-15)) & ((1 << 15) - 1)) );
        $B = $B+($D ^ ($C | (~$A)))+$X[9]+0xeb86d391;
        $B = $C + (($B << 21) | (($B >> (32-21)) & ((1 << 21) - 1)) );
        $A = $A + $AA;
        $B = $B + $BB;
        $C = $C + $CC;
        $D = $D + $DD;
    }
    pack "V4", $A, $B, $C, $D;
}

sub MD5base64 {
    (my $base64 = EncBase64(&MD5)) =~ s/=*\n?$//;
    return $base64;
}

sub MD5hex {
    unpack "H*", &MD5;
}

sub EncBase64 {
    use integer;
    my $len = length($_[0]);
    my $res;
    for my $i (0..($len-1)/99999) {
        my $data = substr($_[0], $i*99999, 99999);
        chop($res .= substr(pack("u200000", $data), 1));
    }
    $res =~ tr/` -_/AA-Za-z0-9+\//;
    my $pad = $len % 3;
    substr($res, $pad-3) = "="x(3-$pad) if $pad;
    $res=~s/(.{1,76})/$1\n/g;
    return $res;
}

1;
