#!/usr/bin/perl -w
use Test;
BEGIN { plan tests => 12, todo => [11,12] }
BEGIN { unshift @INC, "../blib/lib" } 
use POWER::lib qw($TIME);

$test1=0; CronSet("test1", 0.01, sub { $test1++ }); ConkOut(1);
ok($test1, 100,		"CronSet: test1, 0.01");

$test1=0; CronSet("test1", 0.02, sub { $test1++ }); ConkOut(1);
ok($test1, 50,		"CronSet: test1, 0.02");

$test2=0; CronSet("test2", 0.1, sub { $test2++ }); ConkOut(1);
ok($test2, 10,		"CronSet: test2, 0.1");
ok($test1, 100,		"CronSet: test1 + test2");

CronDel("test1"); ConkOut(1); CronDel("test2");
ok($test2, 20,		"CronSet: test2, 0.1 (2 sec)");
ok($test1, 100,		"CronSet: test1 + test2, deleted");

$test3=0; my $name1 = CronSet(undef, 0.01, sub { $test3++ });
$test4=0; my $name2 = CronSet(undef, 0.01, sub { $test4++ });
ConkOut(0.1); CronDel($name1);
ConkOut(0.1); CronDel($name2);
ok($name1, "__AUTO__0",	"name1");
ok($name2, "__AUTO__1",	"name2");
ok($test3, 10,		"CronSet: undef, 0.01 (test3)");
ok($test4, 20,		"CronSet: undef, 0.01 (test4)");

# test for long-running handlers
#$test3=0; CronSet("test3", 0.01, sub { ConkOut(0.1); $test3++ });
#$test4=0; CronSet("test4", 0.01, sub { $test4++ });
#ConkOut(1); CronDel("test3"); CronDel("test4");
ok($test3, 10,		"CronSet: test3, 0.01 + ConkOut");
ok($test4, 110,		"CronSet: test4, 0.01 - ConkOut");

